# About AceCustomizer

Ace-customizer-lib is a small JavaScript library made for Humany/Ace.
Humany / ACE knowledge portals is a service owned and provided by Telia Company.
This library contains custom scripts which can be injected in a Humany portal at runtime, in order to modify the front-end code and UI.

### Node version

12.22.1 is recommended.
gut

### Get started

- Clone the repo
- Run **npm install**
- For development: **npm run dev**
- For production bundling: **npm run prod**

### Preparing the ACE portal

- Open the admin page and navigate to “Interfaces”.
- Select the 3 dots menu button on your portal and select “Custom HTML and JavaScript”.
- Go to “ENABLE CUSTOM HTML AND JAVASCRIPT IN FOOTER
- Insert the script reference to either the bundle.js file or another file you wish to use.
- Write a script tag and put below code to initiate the setup of the mutationObserver:

```
AceCustomizer.setup(
  {
    convertLinks: true,   // Optional
    accordions: true,     // Optional
    resultInfoBox: true   // Optional
  }
)
```

### Publishing new version of package

- Bump the version in package.json
- Run `npm run build`
- Commit the new bundle files and the package.json file
- Login to NPM in the console using `npm adduser`
- Run `npm publish`
- Verify that the new package has been published
- Some files may be fetched directly from the repo, so create a new release in Github now

### Debugging locally with Humany

- Spin up a local dev server
- In Humany admin add a script tag with the src pointing to the file you want to debug on your local server
